## ns3 3.45

=== ns-3.45/CMakeLists.txt ===
# ##############################################################################
# Required CMake version            #
# ##############################################################################
cmake_minimum_required(VERSION 3.13..3.13)

# ##############################################################################
# Project name                        #
# ##############################################################################
project(NS3 CXX C)

file(STRINGS VERSION NS3_VER)

# minimum compiler versions
set(AppleClang_MinVersion 13.1.6)
set(Clang_MinVersion 11.0.0)
set(GNU_MinVersion 10.1.0)

# common options
option(NS3_ASSERT "Enable assert on failure" OFF)
option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
option(NS3_EXAMPLES "Enable examples to be built" OFF)
option(NS3_LOG "Enable logging to be built" OFF)
option(NS3_TESTS "Enable tests to be built" OFF)

# fd-net-device options
option(NS3_EMU "Build with emulation support" ON)
option(NS3_TAP "Build with Tap support" ON)
option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)

# maintenance and documentation
option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
option(NS3_CLANG_TIMETRACE
       "Collect compilation statistics to analyze the build process" OFF
)
option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
option(NS3_COVERAGE "Enable code coverage measurements and report generation"
       OFF
)
option(NS3_COVERAGE_ZERO_COUNTERS
       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
)
option(NS3_INCLUDE_WHAT_YOU_USE
       "Use IWYU to determine unnecessary headers included" OFF
)
option(NS3_LINK_WHAT_YOU_USE
       "Use LWYU to determine unnecessary linked libraries" OFF
)
option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)

# 3rd-party libraries/programs
option(NS3_NETANIM "Build netanim" OFF)

# other options
option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
option(NS3_CPM "Enable the CPM C++ library manager support" OFF)
option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
option(NS3_FETCH_OPTIONAL_COMPONENTS
       "Fetch Brite, Click and Openflow dependencies" OFF
)
option(
  NS3_FORCE_LOCAL_DEPENDENCIES
  "Only search applications, headers, libraries on explicitly set directories"
  OFF
)
option(NS3_GSL "Build with GSL support" ON)
option(NS3_GTK3 "Build with GTK3 support" ON)
option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
option(NS3_MONOLIB
       "Build a single shared ns-3 library and link it against executables" OFF
)
option(NS3_MPI "Build with MPI support" OFF)
option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
option(
  NS3_NINJA_TRACING
  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
  OFF
)
set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
option(NS3_PRECOMPILE_HEADERS
       "Precompile module headers to speed up compilation" ON
)
option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
option(NS3_SQLITE "Build with SQLite support" ON)
option(NS3_EIGEN "Build with Eigen support" ON)
option(NS3_STATIC "Build a static ns-3 library and link it against executables"
       OFF
)
option(NS3_VCPKG "Enable the Vcpkg C++ library manager support" OFF)
option(NS3_VERBOSE "Print additional build system messages" OFF)
option(NS3_VISUALIZER "Build visualizer module" ON)
option(NS3_WARNINGS "Enable compiler warnings" ON)
option(NS3_WARNINGS_AS_ERRORS
       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
)

# Options that either select which modules will get built or disable modules
set(NS3_ENABLED_MODULES ""
    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
)
set(NS3_DISABLED_MODULES "" CACHE STRING
                                  "List of modules to disable (e.g. lte;wimax)"
)

# Filter in the modules from which examples and tests will be built
set(NS3_FILTER_MODULE_EXAMPLES_AND_TESTS
    ""
    CACHE
      STRING
      "List of modules that should have their examples and tests built (e.g. lte;wifi)"
)

# Include macros used below
include(build-support/macros-and-definitions.cmake)

# Scan module libraries
subdirlist(libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/src)

# Scan contribution libraries
subdirlist(contrib_libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/contrib)

# Scan for additional contribution libraries OUTSIDE the ns-3 source directory,
# in the ns-3-external-contrib directory
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib)
  subdirlist(
    external_contrib_libs_to_build
    ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib
  )
  set(contrib_libs_to_build ${contrib_libs_to_build}
                            ${external_contrib_libs_to_build}
  )
endif()

# Before filtering, we need to load settings from .ns3rc
parse_ns3rc(
  ns3rc_enabled_modules ns3rc_disabled_modules ns3rc_examples_enabled
  ns3rc_tests_enabled
)

# After scanning modules, we can filter enabled and disabled ones
filter_enabled_and_disabled_modules(
  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
  ns3rc_enabled_modules ns3rc_disabled_modules
)

if(${NS3_CCACHE})
  # Use ccache if available
  mark_as_advanced(CCACHE)
  find_program(CCACHE ccache)
  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
    message(STATUS "CCache is enabled.")
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    execute_process(
      COMMAND
        ${CCACHE} --set-config
        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
    )
    if(DEFINED MSVC)
      if(MSVC)
        file(COPY_FILE ${CCACHE} ${CMAKE_BINARY_DIR}/clang-cl.exe
             ONLY_IF_DIFFERENT
        )
        set(CMAKE_VS_GLOBALS
            "CLToolExe=clang-cl.exe" "CLToolPath=${CMAKE_BINARY_DIR}"
            "TrackFileAccess=false" "UseMultiToolTask=true"
            "DebugInformationFormat=OldStyle"
        )
      endif()
    endif()
  endif()
endif()

# ##############################################################################
# Process options                     #
# ##############################################################################
process_options()

# ##############################################################################
# Add subdirectories                  #
# ##############################################################################
# Build NS3 library core
add_subdirectory(src)

# Build NS library examples
add_subdirectory(examples)

# Build scratch/simulation scripts
add_subdirectory(scratch)

# Build test utils
add_subdirectory(utils)

write_lock()
write_configtable()

# Export package targets when installing
ns3_cmake_package()

=== ns-3.45/scratch/CMakeLists.txt ===
set(target_prefix scratch_)

function(create_scratch source_files)
  # Return early if no sources in the subdirectory
  list(LENGTH source_files number_sources)
  if(number_sources EQUAL 0)
    return()
  endif()

  # If the scratch has more than a source file, we need to find the source with
  # the main function
  set(scratch_src)
  foreach(source_file ${source_files})
    file(READ ${source_file} source_file_contents)
    string(REGEX MATCHALL "main[(| (]" main_position "${source_file_contents}")
    if(CMAKE_MATCH_0)
      list(APPEND scratch_src ${source_file})
    endif()
  endforeach()

  list(LENGTH scratch_src scratch_src_len)

  # If there is no main function, raise an error
  if(${scratch_src_len} EQUAL 0)
    message(FATAL_ERROR "The following scratch source files do not contain a main function: ${source_files}")
  endif()

  # If there are multiple main functions, raise an error
  if(${scratch_src_len} GREATER 1)
    message(FATAL_ERROR "The following scratch source files contain ${scratch_src_len} files with a main function: ${scratch_src}")
  endif()

  # If there is a single main function, continue normally

  # Get parent directory name
  get_filename_component(scratch_dirname ${scratch_src} DIRECTORY)
  string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "" scratch_dirname
                 "${scratch_dirname}"
  )
  string(REPLACE "/" "_" scratch_dirname "${scratch_dirname}")

  # Get source name
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14.0")
    get_filename_component(scratch_name ${scratch_src} NAME_WLE)
  else()
    get_filename_component(scratch_name ${scratch_src} NAME)
    string(FIND "${scratch_name}" "." ext_position REVERSE)
    if(${ext_position} EQUAL -1)
      message(FATAL_ERROR "Source file has no extension: ${scratch_src}")
    else()
      string(SUBSTRING "${scratch_name}" 0 ${ext_position} scratch_name)
    endif()
  endif()

  set(target_prefix scratch_)
  if(scratch_dirname)
    # Join the names together if dirname is not the scratch folder
    set(target_prefix scratch${scratch_dirname}_)
  endif()

  # Get source absolute path and transform into relative path
  get_filename_component(scratch_src ${scratch_src} ABSOLUTE)
  get_filename_component(scratch_absolute_directory ${scratch_src} DIRECTORY)
  string(REPLACE "${PROJECT_SOURCE_DIR}" "${CMAKE_OUTPUT_DIRECTORY}"
                 scratch_directory ${scratch_absolute_directory}
  )
  build_exec(
          EXECNAME ${scratch_name}
          EXECNAME_PREFIX ${target_prefix}
          SOURCE_FILES "${source_files}"
          LIBRARIES_TO_LINK "${ns3-libs}" "${ns3-contrib-libs}"
          EXECUTABLE_DIRECTORY_PATH ${scratch_directory}/
  )
endfunction()

# Scan *.cc files in ns-3-dev/scratch and build a target for each
file(GLOB single_source_file_scratches CONFIGURE_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/[^.]*.cc)
foreach(scratch_src ${single_source_file_scratches})
  create_scratch(${scratch_src})
endforeach()

# Scan ns-3-dev/scratch subdirectories
file(
  GLOB scratch_subdirectories
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES true
  ${CMAKE_CURRENT_SOURCE_DIR}/**
)
# Filter out files
foreach(entry ${scratch_subdirectories})
  if(NOT (IS_DIRECTORY ${entry}))
    list(REMOVE_ITEM scratch_subdirectories ${entry})
  endif()
endforeach()

# Build scratches per directory or following CMakeLists.txt instructions
foreach(subdir ${scratch_subdirectories})
  if(EXISTS ${subdir}/CMakeLists.txt)
    # If the subdirectory contains a CMakeLists.txt file
    # we let the CMake file manage the source files
    #
    # Use this if you want to link to external libraries
    # without creating a module
    add_subdirectory(${subdir})
  else()
    # Otherwise we pick all the files in the subdirectory
    # and create a scratch for them automatically
    file(GLOB scratch_sources CONFIGURE_DEPENDS ${subdir}/[^.]*.cc)
    create_scratch("${scratch_sources}")
  endif()
endforeach()

=== ns-3.45/contrib/aqm-eval-suite/CMakeLists.txt ===
set(source_files
    model/eval-topology.cc
    model/eval-app.cc
    helper/aqm-eval-suite-helper.cc
    helper/aqm-eval-suite-output-manager.cc
    helper/aqm-eval-suite-plot-manager.cc
)

set(header_files
    model/eval-topology.h
    model/eval-app.h
    helper/aqm-eval-suite-helper.h
    helper/aqm-eval-suite-output-manager.h
    helper/aqm-eval-suite-plot-manager.h
)

build_lib(
  LIBNAME aqm-eval-suite
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${libinternet}
    ${libapplications}
    ${libpoint-to-point}
    ${libpoint-to-point-layout}
)

=== ns-3.45/contrib/lorawan/CMakeLists.txt ===
set(source_files
    model/lora-net-device.cc
    model/lorawan-mac.cc
    model/lora-phy.cc
    model/building-penetration-loss.cc
    model/correlated-shadowing-propagation-loss-model.cc
    model/lora-channel.cc
    model/lora-interference-helper.cc
    model/gateway-lorawan-mac.cc
    model/end-device-lorawan-mac.cc
    model/class-a-end-device-lorawan-mac.cc
    model/gateway-lora-phy.cc
    model/end-device-lora-phy.cc
    model/simple-end-device-lora-phy.cc
    model/simple-gateway-lora-phy.cc
    model/sub-band.cc
    model/logical-lora-channel.cc
    model/logical-lora-channel-helper.cc
    model/periodic-sender.cc
    model/one-shot-sender.cc
    model/forwarder.cc
    model/lorawan-mac-header.cc
    model/lora-frame-header.cc
    model/mac-command.cc
    model/lora-device-address.cc
    model/lora-device-address-generator.cc
    model/lora-tag.cc
    model/network-server.cc
    model/network-status.cc
    model/network-controller.cc
    model/network-controller-components.cc
    model/network-scheduler.cc
    model/end-device-status.cc
    model/gateway-status.cc
    model/lora-radio-energy-model.cc
    model/lora-tx-current-model.cc
    model/lora-utils.cc
    model/adr-component.cc
    model/hex-grid-position-allocator.cc
    helper/lora-radio-energy-model-helper.cc
    helper/lora-helper.cc
    helper/lora-phy-helper.cc
    helper/lorawan-mac-helper.cc
    helper/periodic-sender-helper.cc
    helper/one-shot-sender-helper.cc
    helper/forwarder-helper.cc
    helper/network-server-helper.cc
    helper/lora-packet-tracker.cc
)

set(header_files
    model/lora-net-device.h
    model/lorawan-mac.h
    model/lora-phy.h
    model/building-penetration-loss.h
    model/correlated-shadowing-propagation-loss-model.h
    model/lora-channel.h
    model/lora-interference-helper.h
    model/gateway-lorawan-mac.h
    model/end-device-lorawan-mac.h
    model/class-a-end-device-lorawan-mac.h
    model/gateway-lora-phy.h
    model/end-device-lora-phy.h
    model/simple-end-device-lora-phy.h
    model/simple-gateway-lora-phy.h
    model/sub-band.h
    model/logical-lora-channel.h
    model/logical-lora-channel-helper.h
    model/periodic-sender.h
    model/one-shot-sender.h
    model/forwarder.h
    model/lorawan-mac-header.h
    model/lora-frame-header.h
    model/mac-command.h
    model/lora-device-address.h
    model/lora-device-address-generator.h
    model/lora-tag.h
    model/network-server.h
    model/network-status.h
    model/network-controller.h
    model/network-controller-components.h
    model/network-scheduler.h
    model/end-device-status.h
    model/gateway-status.h
    model/lora-radio-energy-model.h
    model/lora-tx-current-model.h
    model/lora-utils.h
    model/adr-component.h
    model/hex-grid-position-allocator.h
    helper/lora-radio-energy-model-helper.h
    helper/lora-helper.h
    helper/lora-phy-helper.h
    helper/lorawan-mac-helper.h
    helper/periodic-sender-helper.h
    helper/one-shot-sender-helper.h
    helper/forwarder-helper.h
    helper/network-server-helper.h
    helper/lora-packet-tracker.h
    test/utilities.h
)

build_lib(
  LIBNAME lorawan
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK
    ${libenergy}
    ${libpoint-to-point}
    ${libbuildings}
  TEST_SOURCES
    test/utilities.cc
    test/lorawan-test-suite.cc
    test/network-status-test-suite.cc
    test/network-scheduler-test-suite.cc
    test/network-server-test-suite.cc
)

=== ns-3.45/contrib/netsimulyzer/CMakeLists.txt ===
# NIST-developed software is provided by NIST as a public service. You may use,
# copy and distribute copies of the software in any medium, provided that you
# keep intact this entire notice. You may improve,modify and create derivative
# works of the software or any portion of the software, and you may copy and
# distribute such modifications or works. Modified works should carry a notice
# stating that you changed the software and should note the date and nature of
# any such change. Please explicitly acknowledge the National Institute of
# Standards and Technology as the source of the software.
#
# NIST-developed software is expressly provided "AS IS." NIST MAKES NO
# WARRANTY OF ANY KIND, EXPRESS, IMPLIED, IN FACT OR ARISING BY OPERATION OF
# LAW, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT
# AND DATA ACCURACY. NIST NEITHER REPRESENTS NOR WARRANTS THAT THE
# OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT
# ANY DEFECTS WILL BE CORRECTED. NIST DOES NOT WARRANT OR MAKE ANY
# REPRESENTATIONS REGARDING THE USE OF THE SOFTWARE OR THE RESULTS THEREOF,
# INCLUDING BUT NOT LIMITED TO THE CORRECTNESS, ACCURACY, RELIABILITY,
# OR USEFULNESS OF THE SOFTWARE.
#
# You are solely responsible for determining the appropriateness of using and
# distributing the software and you assume all risks associated with its use,
# including but not limited to the risks and costs of program errors,
# compliance with applicable laws, damage to or loss of data, programs or
# equipment, and the unavailability or interruption of operation. This
# software is not intended to be used in any situation where a failure could
# cause risk of injury or damage to property. The software developed by NIST
# employees is not subject to copyright protection within the United States.

# ----- User options -----
option(NETSIMULYZER_PRE_NS3_41_ENUM_VALUE "Force compatibility with ns-3 versions before ns-3.41" OFF)
option(NETSIMULYZER_CRASH_HANDLER "Adds a crash handler that writes NetSimulyzer output on an irregular exit of the program" ON)

find_package (Git)
# Find grep, just in case we need it for version detection later
find_program(NETSIMULYZER_GREP "grep")

# ----- ns-3 version detection -----

# Manually specified ns-3 version, no need to autodetect
if (DEFINED ENV{NETSIMULYZER_NS3_VERSION})
    set(NETSIMULYZER_NS3_VERSION "$ENV{NETSIMULYZER_NS3_VERSION}" CACHE STRING "Detected ns-3 version")

    # Strip the "ns-3." off of the version number
    string(REPLACE "ns-3." "" NETSIMULYZER_NS3_VERSION "${NETSIMULYZER_NS3_VERSION}")

    if (NOT NETSIMULYZER_NS3_VERSION MATCHES "^[0-9]+$")
        message(FATAL_ERROR "Environment variable `NETSIMULYZER_NS3_VERSION` in incorrect format, got `$ENV{NETSIMULYZER_NS3_VERSION}` expected: `ns-3.xx` e.g. `ns-3.45` or just `45`")
    endif ()

# We're on a fixed ns-3 release
elseif (DEFINED NS3_VER AND NOT "${NS3_VER}" STREQUAL "3-dev")
    set(NETSIMULYZER_NS3_VERSION "${NS3_VER}" CACHE STRING "Detected ns-3 version")
    string(REPLACE "3." "" NETSIMULYZER_NS3_VERSION "${NETSIMULYZER_NS3_VERSION}")

# Not manually specified ns-3 version, try and detect from git tags
elseif (GIT_FOUND)
    # Get ns-3 version tags
    # Hopefully not muddied by other project versions
    execute_process(COMMAND "git" "tag" "--list" "ns-3.*" "--sort" "-version:refname"
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            OUTPUT_VARIABLE NETSIMULYZER_DETECTED_NS3_VERSIONS
            COMMAND_ECHO STDERR
    )

    string(REPLACE "ns-3." "" NETSIMULYZER_DETECTED_NS3_VERSIONS "${NETSIMULYZER_DETECTED_NS3_VERSIONS}")
    # Convert to CMake list & sort
    # so the highest number is first
    # Use `NATURAL` sorting to handle double digit numbers and decimals
    string(REPLACE "\n" ";" NETSIMULYZER_DETECTED_NS3_VERSIONS "${NETSIMULYZER_DETECTED_NS3_VERSIONS}")
    list(SORT NETSIMULYZER_DETECTED_NS3_VERSIONS COMPARE NATURAL ORDER DESCENDING)
    list(GET NETSIMULYZER_DETECTED_NS3_VERSIONS 0 NETSIMULYZER_DETECTED_NS3_VERSION)

    set(NETSIMULYZER_NS3_VERSION "${NETSIMULYZER_DETECTED_NS3_VERSION}" CACHE STRING "Detected ns-3 version")
elseif (NETSIMULYZER_GREP)
    # Last resort version detection
    # Huge hack for tar ball ns-3 installs
    # If they don't have `grep` either,
    # then I'm out of options
    #
    # grep 'deprecated.h' for the highest number we can get
    execute_process(COMMAND "grep" "--only-matching" "--extended-regexp" "NS_DEPRECATED_3_[0-9]+" "src/core/model/deprecated.h"
            WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
            OUTPUT_VARIABLE NETSIMULYZER_DEPRECATED_GREP)

    # Strip the 'NS_DEPRECATED_3_' off of the macros
    # so we should have something like: "45\n,44\n43..."
    string(REPLACE "NS_DEPRECATED_3_" "" NETSIMULYZER_DEPRECATED_GREP "${NETSIMULYZER_DEPRECATED_GREP}")
    # Convert to CMake list & sort
    # so the highest number is first
    # Use `NATURAL` sorting to handle double digit numbers and decimals
    string(REPLACE "\n" ";" NETSIMULYZER_DEPRECATED_GREP "${NETSIMULYZER_DEPRECATED_GREP}")
    list(SORT NETSIMULYZER_DEPRECATED_GREP COMPARE NATURAL ORDER DESCENDING)
    list(GET NETSIMULYZER_DEPRECATED_GREP 0 NETSIMULYZER_DETECTED_NS3_VERSION)

    set(NETSIMULYZER_NS3_VERSION "${NETSIMULYZER_DETECTED_NS3_VERSION}" CACHE STRING "Detected ns-3 version")
endif ()


if (NOT NETSIMULYZER_NS3_VERSION AND NOT NETSIMULYZER_NS3_VERSION MATCHES "^[0-9]+$")
    message(FATAL_ERROR "NetSimulyzer: Failed to detect ns-3 version, please specify the `NETSIMULYZER_NS3_VERSION` environment variable in the form: 'ns-3.xx' e.g 'ns-3.45'")
endif ()

add_compile_definitions(NETSIMULYZER_NS3_VERSION=${NETSIMULYZER_NS3_VERSION})

if (${NETSIMULYZER_PRE_NS3_41_ENUM_VALUE} OR ${NETSIMULYZER_NS3_VERSION} LESS 41)
    add_compile_definitions(NETSIMULYZER_PRE_NS3_41_ENUM_VALUE)
endif ()

# ----- Set up model source files -----

build_lib(
  LIBNAME netsimulyzer
  SOURCE_FILES
    helper/area-helper.cc
    helper/building-configuration-container.cc
    helper/building-configuration-helper.cc
    helper/logical-link-helper.cc
    helper/node-configuration-container.cc
    helper/node-configuration-helper.cc
    helper/throughput-sink-helper.cc
    model/node-configuration.cc
    model/building-configuration.cc
    model/category-axis.cc
    model/category-value-series.cc
    model/color.cc
    model/color-palette.cc
    model/decoration.cc
    model/ecdf-sink.cc
    model/log-stream.cc
    model/logical-link.cc
    model/netsimulyzer-version.cc
    model/orchestrator.cc
    model/rectangular-area.cc
    model/series-collection.cc
    model/state-transition-sink.cc
    model/value-axis.cc
    model/xy-series.cc
    model/throughput-sink.cc
  HEADER_FILES
    helper/area-helper.h
    helper/building-configuration-container.h
    helper/building-configuration-helper.h
    helper/logical-link-helper.h
    helper/node-configuration-container.h
    helper/node-configuration-helper.h
    helper/throughput-sink-helper.h
    library/json.hpp
    model/event-message.h
    model/log-stream.h
    model/logical-link.h
    model/netsimulyzer-3D-models.h
    model/netsimulyzer-ns3-compatibility.h
    model/netsimulyzer-version.h
    model/node-configuration.h
    model/optional.h
    model/optional-types.h
    model/building-configuration.h
    model/category-axis.h
    model/category-value-series.h
    model/color.h
    model/color-palette.h
    model/decoration.h
    model/ecdf-sink.h
    model/orchestrator.h
    model/rectangular-area.h
    model/series-collection.h
    model/state-transition-sink.h
    model/value-axis.h
    model/xy-series.h
    model/throughput-sink.h
  LIBRARIES_TO_LINK
    ${libbuildings}
    ${libcore}
    ${libnetwork}
    ${libmobility}
    ${libpoint-to-point}
    ${libapplications}
  TEST_SOURCES
        test/test-buildings.cc
        test/netsimulyzer-test-utils.h
        test/test-node-events.cc
        test/test-orchestrator-outputs.cc
)

# ----- Compiler Defines -----

target_compile_definitions(${libnetsimulyzer} PUBLIC HAS_NETSIMULYZER)

if (NETSIMULYZER_CRASH_HANDLER)
    add_compile_definitions(NETSIMULYZER_CRASH_HANDLER) # TODO: target_compile_definitions _should_ work here, but it doesn't
endif ()

# ----- CMake Define for model detection -----
# This seems to only work with core modules if it's a cached value
set(HAS_NETSIMULYZER TRUE CACHE BOOL "NetSimulyzer ns-3 module")

=== ns-3.45/contrib/netsimulyzer/wscript ===
# -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

# def options(opt):
#     pass


def configure(conf):
    conf.define("HAS_NETSIMULYZER", 1, True, 'Has netsimulyzer module')
    # `waf` was only ever used pre ns-3.41,
    # so we always flag for compatability here
    conf.define("NETSIMULYZER_PRE_NS3_41_ENUM_VALUE", 1, True, 'Use pre ns-3.41 EnumValue compatability')

    # Waf is not used post ns-3.36
    # and we only have compatibility checks for < ns-3.40
    conf.define("NETSIMULYZER_NS3_VERSION", 36, True, 'Version of ns-3 the NetSimulyzer is build for')
    conf.env['HAS_NETSIMULYZER'] = True
    conf.env.append_value('CXXFLAGS', '-std=c++17')


def build(bld):
    module = bld.create_ns3_module('netsimulyzer', ['buildings', 'core', 'network', 'mobility', 'point-to-point'])

    module.source = [
        'helper/area-helper.cc',
        'helper/building-configuration-container.cc',
        'helper/building-configuration-helper.cc',
        'helper/logical-link-helper.cc',
        'helper/node-configuration-container.cc',
        'helper/node-configuration-helper.cc',
        'model/node-configuration.cc',
        'model/building-configuration.cc',
        'model/category-axis.cc',
        'model/category-value-series.cc',
        'model/color.cc',
        'model/color-palette.cc',
        'model/decoration.cc',
        'model/ecdf-sink.cc',
        'model/log-stream.cc',
        'model/logical-link.cc',
        'model/netsimulyzer-version.cc',
        'model/orchestrator.cc',
        'model/rectangular-area.cc',
        'model/series-collection.cc',
        'model/state-transition-sink.cc',
        'model/value-axis.cc',
        'model/xy-series.cc',
        'model/throughput-sink.cc'
        ]

    module_test = bld.create_ns3_module_test_library('netsimulyzer')
    module_test.source = [
        ]

    headers = bld(features='ns3header')
    headers.module = 'netsimulyzer'
    headers.source = [
        'helper/area-helper.h',
        'helper/building-configuration-container.h',
        'helper/building-configuration-helper.h',
        'helper/logical-link-helper.h',
        'helper/node-configuration-container.h',
        'helper/node-configuration-helper.h',
        'library/json.hpp',
        'model/event-message.h',
        'model/log-stream.h',
        'model/logical-link.h',
        'model/netsimulyzer-3D-models.h',
        'model/netsimulyzer-ns3-compatibility.h',
        'model/netsimulyzer-version.h',
        'model/node-configuration.h',
        'model/optional.h',
        'model/optional-types.h',
        'model/building-configuration.h',
        'model/category-axis.h',
        'model/category-value-series.h',
        'model/color.h',
        'model/color-palette.h',
        'model/decoration.h',
        'model/ecdf-sink.h',
        'model/orchestrator.h',
        'model/rectangular-area.h',
        'model/series-collection.h',
        'model/state-transition-sink.h',
        'model/value-axis.h',
        'model/xy-series.h',
        'model/throughput-sink.h'
        ]

    # Examples are not enabled for waf versions of
    # ns-3, since the API has changed so much
    # If you want to try them, uncomment the lines below
    # if bld.env.ENABLE_EXAMPLES:
    #     bld.recurse('examples')

=== ns-3.45/contrib/nr/CMakeLists.txt ===
# Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
#
# SPDX-License-Identifier: GPL-2.0-only

if(${ENABLE_EIGEN})
  set(eigen_sources
      model/nr-mimo-matrices-eigen.cc
  )
  set(eigen_tests
      test/nr-test-csi.cc
      test/nr-test-ri-pmi.cc
  )
else()
  message(
    WARNING "nr MIMO features require the eigen3 library, but it was not found"
  )
  set(eigen_sources
      model/nr-mimo-matrices-no-eigen.cc
  )
  set(eigen_tests)
endif()

set(opengym_sources)
set(opengym_headers)
set(opengym_tests)
set(opengym_libraries)
if(opengym
   IN_LIST
   contrib_libs_to_build
)
  set(opengym_sources
      model/nr-mac-scheduler-ai-ns3-gym-env.cc
      model/nr-mac-scheduler-ofdma-ai.cc
      model/nr-mac-scheduler-tdma-ai.cc
      model/nr-mac-scheduler-ue-info-ai.cc
  )
  set(opengym_headers
      model/nr-mac-scheduler-ai-ns3-gym-env.h
      model/nr-mac-scheduler-ofdma-ai.h
      model/nr-mac-scheduler-tdma-ai.h
      model/nr-mac-scheduler-ue-info-ai.h
  )
  set(opengym_tests
      test/nr-test-scheduler-ai.cc
  )
  set(opengym_libraries
      ${libopengym}
  )
endif()

set(source_files
    ${eigen_sources}
    helper/beamforming-helper-base.cc
    helper/cc-bwp-helper.cc
    helper/file-scenario-helper.cc
    helper/grid-scenario-helper.cc
    helper/hexagonal-grid-scenario-helper.cc
    helper/ideal-beamforming-helper.cc
    helper/node-distribution-scenario-interface.cc
    helper/nr-bearer-stats-calculator.cc
    helper/nr-bearer-stats-connector.cc
    helper/nr-bearer-stats-simple.cc
    helper/nr-channel-helper.cc
    helper/nr-epc-helper.cc
    helper/nr-helper.cc
    helper/nr-mac-rx-trace.cc
    helper/nr-mac-scheduling-stats.cc
    helper/nr-no-backhaul-epc-helper.cc
    helper/nr-phy-rx-trace.cc
    helper/nr-point-to-point-epc-helper-base.cc
    helper/nr-point-to-point-epc-helper.cc
    helper/nr-radio-environment-map-helper.cc
    helper/nr-spectrum-value-helper.cc
    helper/nr-stats-calculator.cc
    helper/realistic-beamforming-helper.cc
    helper/scenario-parameters.cc
    helper/three-gpp-ftp-m1-helper.cc
    model/bandwidth-part-gnb.cc
    model/bandwidth-part-ue.cc
    model/beam-id.cc
    model/beam-manager.cc
    model/beamforming-vector.cc
    model/bwp-manager-algorithm.cc
    model/bwp-manager-gnb.cc
    model/bwp-manager-ue.cc
    model/ideal-beamforming-algorithm.cc
    model/lena-error-model.cc
    model/nr-a2-a4-rsrq-handover-algorithm.cc
    model/nr-a3-rsrp-handover-algorithm.cc
    model/nr-amc.cc
    model/nr-anr.cc
    model/nr-asn1-header.cc
    model/nr-cb-two-port.cc
    model/nr-cb-type-one-sp.cc
    model/nr-cb-type-one.cc
    model/nr-ch-access-manager.cc
    model/nr-chunk-processor.cc
    model/nr-common.cc
    model/nr-component-carrier.cc
    model/nr-control-messages.cc
    model/nr-csi-rs-filter.cc
    model/nr-eesm-cc-t1.cc
    model/nr-eesm-cc-t2.cc
    model/nr-eesm-cc.cc
    model/nr-eesm-error-model.cc
    model/nr-eesm-ir-t1.cc
    model/nr-eesm-ir-t2.cc
    model/nr-eesm-ir.cc
    model/nr-eesm-t1.cc
    model/nr-eesm-t2.cc
    model/nr-epc-gnb-application.cc
    model/nr-epc-gtpc-header.cc
    model/nr-epc-gtpu-header.cc
    model/nr-epc-mme-application.cc
    model/nr-epc-pgw-application.cc
    model/nr-epc-sgw-application.cc
    model/nr-epc-tft-classifier.cc
    model/nr-epc-tft.cc
    model/nr-epc-ue-nas.cc
    model/nr-epc-x2-header.cc
    model/nr-epc-x2.cc
    model/nr-eps-bearer-tag.cc
    model/nr-eps-bearer.cc
    model/nr-error-model.cc
    model/nr-fh-control.cc
    model/nr-fh-phy-sap.cc
    model/nr-fh-sched-sap.cc
    model/nr-gnb-component-carrier-manager.cc
    model/nr-gnb-mac.cc
    model/nr-gnb-net-device.cc
    model/nr-gnb-phy.cc
    model/nr-gnb-rrc.cc
    model/nr-handover-algorithm.cc
    model/nr-harq-phy.cc
    model/nr-initial-association.cc
    model/nr-interference-base.cc
    model/nr-interference.cc
    model/nr-lte-amc.cc
    model/nr-lte-mi-error-model.cc
    model/nr-mac-harq-vector.cc
    model/nr-mac-header-fs-dl.cc
    model/nr-mac-header-fs-ul.cc
    model/nr-mac-header-fs.cc
    model/nr-mac-header-vs-dl.cc
    model/nr-mac-header-vs-ul.cc
    model/nr-mac-header-vs.cc
    model/nr-mac-scheduler-cqi-management.cc
    model/nr-mac-scheduler-harq-rr.cc
    model/nr-mac-scheduler-lc-alg.cc
    model/nr-mac-scheduler-lc-qos.cc
    model/nr-mac-scheduler-lc-rr.cc
    model/nr-mac-scheduler-lcg.cc
    model/nr-mac-scheduler-ns3.cc
    model/nr-mac-scheduler-ofdma-mr.cc
    model/nr-mac-scheduler-ofdma-pf.cc
    model/nr-mac-scheduler-ofdma-qos.cc
    model/nr-mac-scheduler-ofdma-rr.cc
    model/nr-mac-scheduler-ofdma-symbol-per-beam.cc
    model/nr-mac-scheduler-ofdma-random.cc
    model/nr-mac-scheduler-ofdma.cc
    model/nr-mac-scheduler-srs-default.cc
    model/nr-mac-scheduler-tdma-mr.cc
    model/nr-mac-scheduler-tdma-pf.cc
    model/nr-mac-scheduler-tdma-qos.cc
    model/nr-mac-scheduler-tdma-rr.cc
    model/nr-mac-scheduler-tdma-random.cc
    model/nr-mac-scheduler-tdma.cc
    model/nr-mac-scheduler-ue-info-pf.cc
    model/nr-mac-scheduler-ue-info-qos.cc
    model/nr-mac-scheduler-ue-info.cc
    model/nr-mac-scheduler.cc
    model/nr-mac-short-bsr-ce.cc
    model/nr-mimo-chunk-processor.cc
    model/nr-mimo-matrices.cc
    model/nr-mimo-signal.cc
    model/nr-net-device.cc
    model/nr-no-op-component-carrier-manager.cc
    model/nr-no-op-handover-algorithm.cc
    model/nr-pdcp-header.cc
    model/nr-pdcp-tag.cc
    model/nr-pdcp.cc
    model/nr-phy-mac-common.cc
    model/nr-phy-tag.cc
    model/nr-phy.cc
    model/nr-pm-search-fast.cc
    model/nr-pm-search-full.cc
    model/nr-pm-search-ideal.cc
    model/nr-pm-search-sasaoka.cc
    model/nr-pm-search.cc
    model/nr-radio-bearer-info.cc
    model/nr-radio-bearer-tag.cc
    model/nr-rlc-am-header.cc
    model/nr-rlc-am.cc
    model/nr-rlc-header.cc
    model/nr-rlc-sdu-status-tag.cc
    model/nr-rlc-sequence-number.cc
    model/nr-rlc-tag.cc
    model/nr-rlc-tm.cc
    model/nr-rlc-um.cc
    model/nr-rlc.cc
    model/nr-rrc-header.cc
    model/nr-rrc-protocol-ideal.cc
    model/nr-rrc-protocol-real.cc
    model/nr-simple-ue-component-carrier-manager.cc
    model/nr-spectrum-phy.cc
    model/nr-spectrum-signal-parameters.cc
    model/nr-ue-component-carrier-manager.cc
    model/nr-ue-mac.cc
    model/nr-ue-net-device.cc
    model/nr-ue-phy.cc
    model/nr-ue-power-control.cc
    model/nr-ue-rrc.cc
    model/nr-vendor-specific-parameters.cc
    model/realistic-beamforming-algorithm.cc
    model/realistic-bf-manager.cc
    model/resource-assignment-matrix.cc
    model/sfnsf.cc
    utils/channels/nyu/nyu-channel-condition-model.cc
    utils/channels/nyu/nyu-channel-model.cc
    utils/channels/nyu/nyu-propagation-loss-model.cc
    utils/channels/nyu/nyu-spectrum-propagation-loss-model.cc
    utils/distance-based-three-gpp-spectrum-propagation-loss-model.cc
    utils/fast-fading-constant-position-mobility-model.cc
    utils/parse-string-to-vector.cc
    utils/traffic-generators/helper/traffic-generator-helper.cc
    utils/traffic-generators/helper/xr-traffic-mixer-helper.cc
    utils/traffic-generators/model/traffic-generator-3gpp-audio-data.cc
    utils/traffic-generators/model/traffic-generator-3gpp-generic-video.cc
    utils/traffic-generators/model/traffic-generator-3gpp-pose-control.cc
    utils/traffic-generators/model/traffic-generator-ftp-single.cc
    utils/traffic-generators/model/traffic-generator-ngmn-ftp-multi.cc
    utils/traffic-generators/model/traffic-generator-ngmn-gaming.cc
    utils/traffic-generators/model/traffic-generator-ngmn-video.cc
    utils/traffic-generators/model/traffic-generator-ngmn-voip.cc
    utils/traffic-generators/model/traffic-generator.cc
    utils/wraparound-model/hexagonal-wraparound-model.cc
    utils/wraparound-three-gpp-spectrum-propagation-loss-model.cc
)

set(header_files
    helper/beamforming-helper-base.h
    helper/cc-bwp-helper.h
    helper/file-scenario-helper.h
    helper/grid-scenario-helper.h
    helper/hexagonal-grid-scenario-helper.h
    helper/ideal-beamforming-helper.h
    helper/node-distribution-scenario-interface.h
    helper/nr-bearer-stats-calculator.h
    helper/nr-bearer-stats-connector.h
    helper/nr-bearer-stats-simple.h
    helper/nr-channel-helper.h
    helper/nr-epc-helper.h
    helper/nr-helper.h
    helper/nr-mac-rx-trace.h
    helper/nr-mac-scheduling-stats.h
    helper/nr-no-backhaul-epc-helper.h
    helper/nr-phy-rx-trace.h
    helper/nr-point-to-point-epc-helper-base.h
    helper/nr-point-to-point-epc-helper.h
    helper/nr-radio-environment-map-helper.h
    helper/nr-spectrum-value-helper.h
    helper/nr-stats-calculator.h
    helper/realistic-beamforming-helper.h
    helper/scenario-parameters.h
    helper/three-gpp-ftp-m1-helper.h
    model/bandwidth-part-gnb.h
    model/bandwidth-part-ue.h
    model/beam-id.h
    model/beam-manager.h
    model/beamforming-vector.h
    model/bwp-manager-algorithm.h
    model/bwp-manager-gnb.h
    model/bwp-manager-ue.h
    model/ideal-beamforming-algorithm.h
    model/lena-error-model.h
    model/nr-a2-a4-rsrq-handover-algorithm.h
    model/nr-a3-rsrp-handover-algorithm.h
    model/nr-amc.h
    model/nr-anr-sap.h
    model/nr-anr.h
    model/nr-as-sap.h
    model/nr-asn1-header.h
    model/nr-cb-two-port.h
    model/nr-cb-type-one-sp.h
    model/nr-cb-type-one.h
    model/nr-ccm-mac-sap.h
    model/nr-ccm-rrc-sap.h
    model/nr-ch-access-manager.h
    model/nr-chunk-processor.h
    model/nr-common.h
    model/nr-component-carrier.h
    model/nr-control-messages.h
    model/nr-csi-rs-filter.h
    model/nr-eesm-cc-t1.h
    model/nr-eesm-cc-t2.h
    model/nr-eesm-cc.h
    model/nr-eesm-error-model.h
    model/nr-eesm-ir-t1.h
    model/nr-eesm-ir-t2.h
    model/nr-eesm-ir.h
    model/nr-eesm-t1.h
    model/nr-eesm-t2.h
    model/nr-epc-gnb-application.h
    model/nr-epc-gnb-s1-sap.h
    model/nr-epc-gtpc-header.h
    model/nr-epc-gtpu-header.h
    model/nr-epc-mme-application.h
    model/nr-epc-pgw-application.h
    model/nr-epc-s11-sap.h
    model/nr-epc-s1ap-sap.h
    model/nr-epc-sgw-application.h
    model/nr-epc-tft-classifier.h
    model/nr-epc-tft.h
    model/nr-epc-ue-nas.h
    model/nr-epc-x2-header.h
    model/nr-epc-x2-sap.h
    model/nr-epc-x2.h
    model/nr-eps-bearer-tag.h
    model/nr-eps-bearer.h
    model/nr-error-model.h
    model/nr-fh-control.h
    model/nr-fh-phy-sap.h
    model/nr-fh-sched-sap.h
    model/nr-gnb-cmac-sap.h
    model/nr-gnb-component-carrier-manager.h
    model/nr-gnb-cphy-sap.h
    model/nr-gnb-mac.h
    model/nr-gnb-net-device.h
    model/nr-gnb-phy.h
    model/nr-gnb-rrc.h
    model/nr-handover-algorithm.h
    model/nr-handover-management-sap.h
    model/nr-harq-phy.h
    model/nr-initial-association.h
    model/nr-interference-base.h
    model/nr-interference.h
    model/nr-lte-amc.h
    model/nr-lte-mi-error-model.h
    model/nr-mac-csched-sap.h
    model/nr-mac-harq-process.h
    model/nr-mac-harq-vector.h
    model/nr-mac-header-fs-dl.h
    model/nr-mac-header-fs-ul.h
    model/nr-mac-header-fs.h
    model/nr-mac-header-vs-dl.h
    model/nr-mac-header-vs-ul.h
    model/nr-mac-header-vs.h
    model/nr-mac-pdu-info.h
    model/nr-mac-sap.h
    model/nr-mac-sched-sap.h
    model/nr-mac-scheduler-cqi-management.h
    model/nr-mac-scheduler-harq-rr.h
    model/nr-mac-scheduler-lc-alg.h
    model/nr-mac-scheduler-lc-qos.h
    model/nr-mac-scheduler-lc-rr.h
    model/nr-mac-scheduler-lcg.h
    model/nr-mac-scheduler-ns3.h
    model/nr-mac-scheduler-ofdma-mr.h
    model/nr-mac-scheduler-ofdma-pf.h
    model/nr-mac-scheduler-ofdma-qos.h
    model/nr-mac-scheduler-ofdma-rr.h
    model/nr-mac-scheduler-ofdma-symbol-per-beam.h
    model/nr-mac-scheduler-ofdma-random.h
    model/nr-mac-scheduler-ofdma.h
    model/nr-mac-scheduler-srs-default.h
    model/nr-mac-scheduler-srs.h
    model/nr-mac-scheduler-tdma-mr.h
    model/nr-mac-scheduler-tdma-pf.h
    model/nr-mac-scheduler-tdma-qos.h
    model/nr-mac-scheduler-tdma-rr.h

=== ns-3.45/contrib/nr/Makefile ===
# Copyright (c) 2022 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
#
# SPDX-License-Identifier: GPL-2.0-only

all:
	@echo "Usage: make docs"

docs:
	doxygen doc/doxygen.conf

=== ns-3.45/contrib/oran/CMakeLists.txt ===
# NIST-developed software is provided by NIST as a public service. You may use,
# copy and distribute copies of the software in any medium, provided that you
# keep intact this entire notice. You may improve,modify and create derivative
# works of the software or any portion of the software, and you may copy and
# distribute such modifications or works. Modified works should carry a notice
# stating that you changed the software and should note the date and nature of
# any such change. Please explicitly acknowledge the National Institute of
# Standards and Technology as the source of the software.
#
# NIST-developed software is expressly provided "AS IS." NIST MAKES NO
# WARRANTY OF ANY KIND, EXPRESS, IMPLIED, IN FACT OR ARISING BY OPERATION OF
# LAW, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT
# AND DATA ACCURACY. NIST NEITHER REPRESENTS NOR WARRANTS THAT THE
# OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT
# ANY DEFECTS WILL BE CORRECTED. NIST DOES NOT WARRANT OR MAKE ANY
# REPRESENTATIONS REGARDING THE USE OF THE SOFTWARE OR THE RESULTS THEREOF,
# INCLUDING BUT NOT LIMITED TO THE CORRECTNESS, ACCURACY, RELIABILITY,
# OR USEFULNESS OF THE SOFTWARE.
#
# You are solely responsible for determining the appropriateness of using and
# distributing the software and you assume all risks associated with its use,
# including but not limited to the risks and costs of program errors,
# compliance with applicable laws, damage to or loss of data, programs or
# equipment, and the unavailability or interruption of operation. This
# software is not intended to be used in any situation where a failure could
# cause risk of injury or damage to property. The software developed by NIST
# employees is not subject to copyright protection within the United States.

if(NOT ${ENABLE_SQLITE})
  message(STATUS "ORAN requires sqlite3 library")
  return()
else()
  set(sqlite_libraries
      ${SQLite3_LIBRARIES}
  )
endif()

if(DEFINED ENV{LIBTORCHPATH})
  find_external_library(DEPENDENCY_NAME Torch
                        HEADER_NAME
                          torch/script.h
                          torch.h
                        LIBRARY_NAME torch
                        SEARCH_PATHS $ENV{LIBTORCHPATH})
else()
  find_external_library(DEPENDENCY_NAME Torch
                        HEADER_NAME
                          torch/script.h
                          torch.h
                        LIBRARY_NAME torch)
endif()

if(${Torch_FOUND})
  include_directories(${Torch_INCLUDE_DIRS})
  link_libraries(${Torch_LIBRARIES})
endif()

set(torch_libraries)
set(oran_torch_sources)
set(oran_torch_headers)
if(${Torch_FOUND})
  set(torch_libraries ${Torch_LIBRARIES})
  set(oran_torch_sources
      model/oran-lm-lte-2-lte-torch-handover.cc
  )
  set(oran_torch_headers
      model/oran-lm-lte-2-lte-torch-handover.h
  )
endif()

if(DEFINED ENV{LIBONNXPATH})
  find_external_library(DEPENDENCY_NAME OnnxRuntime
                        HEADER_NAME
                          cpu_provider_factory.h
                          onnxruntime_c_api.h
                          onnxruntime_cxx_api.h
                          onnxruntime_run_options_config_keys.h
                          onnxruntime_session_options_config_keys.h
                          provider_options.h
                        LIBRARY_NAME onnxruntime
                        SEARCH_PATHS $ENV{LIBONNXPATH})
else()
  find_external_library(DEPENDENCY_NAME OnnxRuntime
                        HEADER_NAME
                          cpu_provider_factory.h
                          onnxruntime_c_api.h
                          onnxruntime_cxx_api.h
                          onnxruntime_run_options_config_keys.h
                          onnxruntime_session_options_config_keys.h
                          provider_options.h
                        LIBRARY_NAME onnxruntime)
endif()

if(${OnnxRuntime_FOUND})
  include_directories(${OnnxRuntime_INCLUDE_DIRS})
  link_libraries(${OnnxRuntime_LIBRARIES})
endif()

set(onnxruntime_libraries)
set(oran_onnxruntime_sources)
set(oran_onnxruntime_headers)
if(${OnnxRuntime_FOUND})
  set(onnxruntime_libraries ${OnnxRuntime_LIBRARIES})
  set(oran_onnxruntime_sources
      model/oran-lm-lte-2-lte-onnx-handover.cc
  )
  set(oran_onnxruntime_headers
      model/oran-lm-lte-2-lte-onnx-handover.h
  )
endif()

build_lib(
  LIBNAME oran
  SOURCE_FILES
    model/oran-near-rt-ric.cc
    model/oran-lm.cc
    model/oran-lm-noop.cc
    model/oran-lm-lte-2-lte-distance-handover.cc
    model/oran-lm-lte-2-lte-rsrp-handover.cc
    model/oran-cmm.cc
    model/oran-cmm-handover.cc
    model/oran-cmm-noop.cc
    model/oran-cmm-single-command-per-node.cc
    model/oran-command.cc
    model/oran-command-lte-2-lte-handover.cc
    model/oran-report.cc
    model/oran-report-apploss.cc
    model/oran-report-lte-ue-rsrp-rsrq.cc
    model/oran-report-location.cc
    model/oran-report-lte-ue-cell-info.cc
    model/oran-reporter.cc
    model/oran-reporter-apploss.cc
    model/oran-reporter-lte-ue-rsrp-rsrq.cc
    model/oran-reporter-location.cc
    model/oran-reporter-lte-ue-cell-info.cc
    model/oran-data-repository.cc
    model/oran-data-repository-sqlite.cc
    model/oran-near-rt-ric-e2terminator.cc
    model/oran-e2-node-terminator.cc
    model/oran-e2-node-terminator-wired.cc
    model/oran-e2-node-terminator-lte-enb.cc
    model/oran-e2-node-terminator-lte-ue.cc
    model/oran-e2-node-terminator-container.cc
    model/oran-report-trigger.cc
    model/oran-report-trigger-periodic.cc
    model/oran-report-trigger-lte-ue-handover.cc
    model/oran-report-trigger-location-change.cc
    model/oran-query-trigger.cc
    model/oran-query-trigger-noop.cc
    model/oran-query-trigger-custom.cc
    helper/oran-helper.cc
    ${oran_onnxruntime_sources}
    ${oran_torch_sources}
  HEADER_FILES
    model/oran-near-rt-ric.h
    model/oran-lm.h
    model/oran-lm-noop.h
    model/oran-lm-lte-2-lte-distance-handover.h
    model/oran-lm-lte-2-lte-rsrp-handover.h
    model/oran-cmm.h
    model/oran-cmm-handover.h
    model/oran-cmm-noop.h
    model/oran-cmm-single-command-per-node.h
    model/oran-command.h
    model/oran-command-lte-2-lte-handover.h
    model/oran-report.h
    model/oran-report-apploss.h
    model/oran-report-lte-ue-rsrp-rsrq.h
    model/oran-report-location.h
    model/oran-report-lte-ue-cell-info.h
    model/oran-reporter.h
    model/oran-reporter-apploss.h
    model/oran-reporter-lte-ue-rsrp-rsrq.h
    model/oran-reporter-location.h
    model/oran-reporter-lte-ue-cell-info.h
    model/oran-data-repository.h
    model/oran-data-repository-sqlite.h
    model/oran-near-rt-ric-e2terminator.h
    model/oran-e2-node-terminator.h
    model/oran-e2-node-terminator-wired.h
    model/oran-e2-node-terminator-lte-enb.h
    model/oran-e2-node-terminator-lte-ue.h
    model/oran-e2-node-terminator-container.h
    model/oran-report-trigger.h
    model/oran-report-trigger-periodic.h
    model/oran-report-trigger-lte-ue-handover.h
    model/oran-report-trigger-location-change.h
    model/oran-query-trigger.h
    model/oran-query-trigger-custom.h
    helper/oran-helper.h
    ${oran_onnxruntime_headers}
    ${oran_torch_headers}
  LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${liblte}
    ${sqlite_libraries}
    ${torch_libraries}
    ${onnxruntime_libraries}
  TEST_SOURCES
    test/oran-test-suite.cc
)

target_compile_definitions(${liboran} PUBLIC ENABLE_ORAN)

=== ns-3.45/contrib/quantum/CMakeLists.txt ===
include_directories(${QPP_INCLUDE_DIR}/qpp)
message(STATUS "Quantum++ include dir: ${QPP_INCLUDE_DIR}")

include_directories(${CryptoPP_INCLUDE_DIRS})
message(STATUS "Crypto++ include dir: ${CryptoPP_INCLUDE_DIRS}")

check_include_file_cxx(
  stdint.h
  HAVE_STDINT_H
)
if(HAVE_STDINT_H)
  add_definitions(-DHAVE_STDINT_H)
endif()

set(examples_as_tests_sources)
if(${ENABLE_EXAMPLES})
  set(examples_as_tests_sources # test/qkd-examples-test-suite.cc
  )
endif()

mark_as_advanced(ENABLE_QPP)

set(ENABLE_QPP
    False
    CACHE INTERNAL
          ""
)

mark_as_advanced(ENABLE_CRYPTOPP)

set(ENABLE_CRYPTOPP
    False
    CACHE INTERNAL
          ""
)

if(${NS3_QPP})
  if(PKG_CONFIG_FOUND)
    if(QPP_FOUND)
      message(STATUS "Quantum++ found")
      set(ENABLE_QPP
          True
          CACHE INTERNAL
                ""
      )
    else()
      message(FATAL_ERROR "Quantum++ not found")
    endif()
  else()
    message(
      FATAL_ERROR "PkgConfig not found. This is required to find Quantum++."
    )
  endif()
endif()

set(qpp_sources)
set(qpp_headers)
set(qpp_libraries)

if(${ENABLE_QPP})
  set(qpp_sources
      helper/quantum-helper.cc
  )
  set(qpp_headers
      helper/quantum-helper.h
  )
  add_definitions(-DENABLE_QPP_QKD)
  set(qpp_libraries
      ${LIB_AS_NEEDED_PRE}
      ${LIB_AS_NEEDED_POST}
  )
endif()

if(${NS3_CRYPTOPP})
  if(PKG_CONFIG_FOUND)
    if(CRYPTOPP_FOUND)
      message(STATUS "Crypto++ found")
      set(ENABLE_CRYPTOPP
          True
          CACHE INTERNAL
                ""
      )
    else()
      message(FATAL_ERROR "Crypto++ not found")
    endif()
  else()
    message(
      FATAL_ERROR "PkgConfig not found. This is required to find Crypto++."
    )
  endif()
endif()

set(crypto_sources)
set(crypto_headers)
set(crypto_libraries)

if(${ENABLE_CRYPTOPP})
  set(crypto_sources
      utils/symmetric-encryption.cc
      utils/hashing.cc
  )
  set(crypto_headers
      utils/symmetric-encryption.h
      utils/hashing.h
  )
  add_definitions(-DENABLE_CRYPTOPP_QKD)
  set(crypto_libraries
      ${LIB_AS_NEEDED_PRE}
      ${CRYPTOPP_LIBRARIES}
      ${LIB_AS_NEEDED_POST}
  )
endif()

set(source_files
    ${crypto_sources}
    ${qpp_sources}
    utils/qkd-data-collector.cc
    model/qkd-header.cc
    model/qkd-protocol.cc
    model/qkd-device.cc
    model/qkd-key-manager.cc
    model/qkd-key-management-layer.cc
    model/quantum-channel.cc
    model/quantum-device.cc
    model/qkd-app-header.cc
    model/qkd-app-trailer.cc
    model/qkd-key-manager-application.cc
    model/qkd-sender.cc
    model/qkd-receiver.cc
    helper/qkd-app-helper.cc
)

set(header_files
    ${crypto_headers}
    ${qpp_headers}
    utils/qkd-data-collector.h
    model/qkd-header.h
    model/qkd-protocol.h
    model/qkd-device.h
    model/qkd-key-manager.h
    model/qkd-key-management-layer.h
    model/quantum-channel.h
    model/quantum-device.h
    model/qkd-app-header.h
    model/qkd-app-trailer.h
    model/qkd-key-manager-application.h
    model/qkd-sender.h
    model/qkd-receiver.h
    helper/qkd-app-helper.h
)

set(libraries_to_link
    ${libapplications}
    ${libcore}
    ${libstats}
    ${libnetwork}
    ${libinternet}
    ${crypto_libraries}
    ${qpp_libraries}
)
if(${ENABLE_QPP}
   AND ${ENABLE_CRYPTOPP}
)

  build_lib(
    LIBNAME quantum
    SOURCE_FILES ${source_files}
    HEADER_FILES ${header_files}
    LIBRARIES_TO_LINK ${libraries_to_link}
    TEST_SOURCES test/symmetric-encryption-test.cc
                 ${examples_as_tests_sources}
  )

  target_link_libraries(
    quantum
    PRIVATE cryptopp
  )
endif()

=== ns-3.45/contrib/sip/CMakeLists.txt ===
# NIST-developed software is provided by NIST as a public service. You may use,
# copy and distribute copies of the software in any medium, provided that you
# keep intact this entire notice. You may improve,modify and create derivative
# works of the software or any portion of the software, and you may copy and
# distribute such modifications or works. Modified works should carry a notice
# stating that you changed the software and should note the date and nature of
# any such change. Please explicitly acknowledge the National Institute of
# Standards and Technology as the source of the software.
#
# NIST-developed software is expressly provided "AS IS." NIST MAKES NO
# WARRANTY OF ANY KIND, EXPRESS, IMPLIED, IN FACT OR ARISING BY OPERATION OF
# LAW, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT
# AND DATA ACCURACY. NIST NEITHER REPRESENTS NOR WARRANTS THAT THE
# OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR-FREE, OR THAT
# ANY DEFECTS WILL BE CORRECTED. NIST DOES NOT WARRANT OR MAKE ANY
# REPRESENTATIONS REGARDING THE USE OF THE SOFTWARE OR THE RESULTS THEREOF,
# INCLUDING BUT NOT LIMITED TO THE CORRECTNESS, ACCURACY, RELIABILITY,
# OR USEFULNESS OF THE SOFTWARE.
#
# You are solely responsible for determining the appropriateness of using and
# distributing the software and you assume all risks associated with its use,
# including but not limited to the risks and costs of program errors,
# compliance with applicable laws, damage to or loss of data, programs or
# equipment, and the unavailability or interruption of operation. This
# software is not intended to be used in any situation where a failure could
# cause risk of injury or damage to property. The software developed by NIST
# employees is not subject to copyright protection within the United States.

build_lib(
    LIBNAME sip
    SOURCE_FILES
    model/sip-agent.cc
    model/sip-element.cc
    model/sip-header.cc
    model/sip-proxy.cc
    HEADER_FILES
    model/sip-agent.h
    model/sip-element.h
    model/sip-header.h
    model/sip-proxy.h
    model/sip-transaction.h
    TEST_SOURCES
    test/sip-test-suite.cc
    LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${libinternet}
)

=== ns-3.45/contrib/uart-net-device/CMakeLists.txt ===
check_include_files(
  "boost/asio.hpp"
  HAVE_BOOST_ASIO
  LANGUAGE
  CXX
)

if(${HAVE_BOOST_ASIO})
  add_definitions(-DHAVE_BOOST_ASIO)
  message(STATUS "Boost Asynchronous IO (ASIO) have been found.")
else()
  message(
    STATUS
      "Boost asio are required for UART operations"
      " Ubuntu ships it within the libboost-dev package."
      " You may need to clean up the CMake cache after installing it to pass this check."
  )
endif()

build_lib(
  LIBNAME uart-net-device
  SOURCE_FILES
    helper/uart-lr-wpan-helper.cc
    model/uart-lr-wpan-net-device.cc
    model/uart-lr-wpan-mac.cc
  HEADER_FILES
    helper/uart-lr-wpan-helper.h
    model/uart-lr-wpan-net-device.h
    model/uart-lr-wpan-mac.h
  LIBRARIES_TO_LINK ${libboost}
                    ${liblrwpan}
)

=== debian/changelog ===
ns3 (3.45-1) unstable; urgency=medium

  * New upstream version.
  * Disable the documentation package to save space on the servers.
    It's probably more useful on the ns-3 web server anyway.
  * Remove the now unused build-dep on goocanvas (Closes: #1112443).

 -- Martin Quinson <mquinson@debian.org>  Fri, 29 Aug 2025 17:16:44 +0200

ns3 (3.44-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Thu, 20 Mar 2025 10:53:57 +0100

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.6.2
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: YunQiang Su <syq@debian.org>
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 dh-exec (>= 0.13),
 dh-python,
 dpkg (>= 1.16.1),
 flex,
# jdupes,
 libboost-filesystem-dev,
 libgsl-dev,
 libsqlite3-dev,
 libxml2-dev,
 pkg-config,
 python3-dev,
 python3-gi,
 python3-gi-cairo,
 python3-pygraphviz,
 gir1.2-gtk-3.0,
Build-Depends-Indep:
 libgraphviz-dev,
 quilt (>= 0.46-7~),
 ipython3,
# dia,
# doxygen,
# dvipng,
# ghostscript,
# imagemagick,
# latexmk,
# python3-sphinx,
# tex-gyre,
# texlive-font-utils,
# texlive-latex-extra,
# texlive-latex-base,
# texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: https://www.nsnam.org/
Vcs-Git: https://salsa.debian.org/debian/ns3.git

Package: ns3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python3-ns3.

# Package: ns3-doc
# Architecture: all
# Build-Profiles: <!nodoc>
# Multi-Arch: foreign
# Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery, libjs-sphinxdoc
# Section: doc
# Description: documentation for ns-3
#  ns-3 is a discrete-event network simulator for Internet systems,
#  targeted primarily for research and educational use.
#  ns-3 is free software, licensed under the GNU GPLv2 license,
#  and is publicly available for research, development, and use.
#  ns-3 is intended as an eventual replacement for the popular
#  ns-2 simulator. The project acronym “nsnam” derives
#  historically from the concatenation of ns (network simulator)
#  and NAM (network animator).
#  .
#  This package contains manual, modules, tutorial and doxygen.

# Note to self: when updating this, you also need to update the SONAME in the relevant patch
Package: libns3.45
Provides: ${t64:Provides}
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains shared libraries.

Package: libns3-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libns3.45 (= ${binary:Version}),
  g++,
Breaks: ns3 (= 3.25+dfsg2-2)
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains static libraries, header files.

#Package: python3-ns3
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
#  python3-pygraphviz
#Section: python
#Suggests: tcpdump
#Breaks: python-ns3
#Description: Python binding of ns3
# ns-3 is a discrete-event network simulator for Internet systems,
# targeted primarily for research and educational use.
# ns-3 is free software, licensed under the GNU GPLv2 license,
# and is publicly available for research, development, and use.
# ns-3 is intended as an eventual replacement for the popular
# ns-2 simulator. The project acronym “nsnam” derives
# historically from the concatenation of ns (network simulator)
# and NAM (network animator).
# .
# This package contains Python binding of ns3.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Drop the debug symbols all together on mipsel to avoid OOM causing FTBFS
  export DEB_CFLAGS_MAINT_STRIP=-g
  export DEB_CXXFLAGS_MAINT_STRIP=-g
endif

# Define CFLAGS and friends to harden the build -- must come any addtion to these variables
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_HOST_GNU_CPU),mipsel)
  # Further reduce the memory consumption on mipsel
  LDFLAGS += -Wl,--reduce-memory-overheads -Wl,--no-keep-memory
endif

TOPDIR=$(CURDIR)
NS3_DIR=$(shell ls -d ns-*)
PYBINDGENV_DIR=$(shell ls -d pybindgen-*)

# Build in parallel, unless there is less than 3GiB
MEMORY=$(shell awk '/MemTotal:/{print $$2}' /proc/meminfo)
CPU_CORES=$(shell nproc)
BUILD_OPTION=$(shell if [ $(MEMORY) -lt 3090252 ]; then echo "-j1"; else echo "-j$(CPU_CORES)"; fi)

include /usr/share/dpkg/architecture.mk

# Reproducible Build wants us to use always the same date when building the documentation
include /usr/share/dpkg/pkg-info.mk
SPHINXOPTS := -D today=\"$(SOURCE_DATE_EPOCH)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(SOURCE_DATE_EPOCH)\"

# Include version information
VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+dfsg.*//' | sed -e 's/\+ds.*//')
MAJOR_VERSION=$(word 1,$(subst ., ,$(VERSION)))
MINOR_VERSION=$(word 2,$(subst ., ,$(VERSION)))
PATCH_VERSION=$(word 3,$(subst ., ,$(VERSION).0)) # Add an extra .0 just in case there is no patch level

BUILD_PROFILE=release

%:
	dh $@ --with python3

# Set up version cache to allow generating version module. The double 0 is due to a CMake peculiarity.

execute_before_dh_auto_configure:
	cd $(NS3_DIR) ; \
	sed -e "s/@NS3_VERSION_CLOSEST_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_COMMIT_HASH@//" \
	    -e "s/@NS3_VERSION_DIRTY_FLAG@/1/" \
	    -e "s/@NS3_VERSION_MAJOR@/$(MAJOR_VERSION)/" \
	    -e "s/@NS3_VERSION_MINOR@/$(MINOR_VERSION)/" \
	    -e "s/@NS3_VERSION_PATCH@/$(PATCH_VERSION)/" \
	    -e "s/@NS3_VERSION_RELEASE_CANDIDATE@//" \
	    -e "s/@NS3_VERSION_TAG@/NONEXISTENT_TAG__PACKAGE_BUILT_FROM_DEBIAN_SOURCE/" \
	    -e "s/@NS3_VERSION_TAG_DISTANCE@/00/" \
	    -e "s/@NS3_VERSION_BUILD_PROFILE@/$(BUILD_PROFILE)/" \
	    build-support/version.cache.in > src/core/model/version.cache

# Use the ns3 wrapper over cmake because I fail to get it work otherwise,
# but pass the parameters that cmake needs to build a proper Debian package (copied from the simgrid build logs)

override_dh_auto_configure:
	cd $(NS3_DIR) ; ./ns3 configure --verbose \
		--build-profile=$(BUILD_PROFILE) --enable-python-bindings --enable-logs --enable-examples --enable-tests --disable-mpi --enable-build-version \
                --prefix=/usr -- \
		-DCMAKE_INSTALL_SYSCONFDIR=/etc -DCMAKE_INSTALL_LOCALSTATEDIR=/var -DCMAKE_EXPORT_NO_PACKAGE_REGISTRY=ON -DCMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY=ON \
		-DCMAKE_INSTALL_RUNSTATEDIR=/run -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) -DCMAKE_INSTALL_PREFIX=/usr

override_dh_auto_build-arch:
	cd $(NS3_DIR) ; ./ns3 build --verbose

# override_dh_auto_build-indep:
# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
#	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v sphinx"
#	cd $(NS3_DIR) ; export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v sphinx
#	echo "XXXX done: ./ns3 docs sphinx"
# 	echo "XXXX run: SPHINXOPTS='$(SPHINXOPTS)' ./ns3 docs -v html"
# 	cd $(NS3_DIR) ; export SPHINXOPTS="$(SPHINXOPTS)"; ./ns3 docs -v html
# 	echo "XXXX done: ./ns3 docs -v html"
# 	rm -f ns-3.*/doc/*/build/*/_static/jquery.js
# 	rm -f ns-3.*/doc/*/build/*/_static/underscore.js
# else
# 	for d in manual models tutorial ; do mkdir -p $(NS3_DIR)/doc/$$d/build/html ; touch $(NS3_DIR)/doc/$$d/build/html/index.html ; done
# endif
# 	touch $@

override_dh_auto_install:
	here=$(CURDIR); cd $(NS3_DIR) ; \
		DESTDIR=$${here}/debian/tmp AM_UPDATE_INFO_DIR=no INSTALL="install --strip-program=true" \
		./ns3 install
	
	mkdir -p debian/tmp/usr/bin
	# cp netanim-*/NetAnim debian/tmp/usr/bin
	# Install my own little script as a compiler
	set -e ;\
	all_libs=$$(find debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ -name 'libns3*.so' | sed -e "s|debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/||" -e 's/.so$$//' | sort) ;\
	sed -e "s/@ALL_LIBS@/$$(echo $$all_libs)/g" debian/ns3++.in > debian/tmp/usr/bin/ns3++
	chmod +x debian/tmp/usr/bin/ns3++
	# Install the upstream changelog as NEWS, as requested by the policy
	(cd ns-3.*; cp RELEASE_NOTES.md NEWS.md)
	
override_dh_auto_test:
	-cd ./$(NS3_DIR); ./test.py -v

override_dh_installchangelogs:
	dh_installchangelogs ./$(NS3_DIR)/CHANGES.md

# override_dh_link:
# 	dh_link
# 	if test -e debian/ns3-doc/usr/share/doc; then \
# 		jdupes -rl debian/ns3-doc/usr/share/doc; \
# 	fi
# 
# override_dh_install:
# 	dh_install
# 	
# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# 	# The doc is not built when building only for a given arch (it's built in 'arch:all')
# 	if [ -e debian/ns3-doc/usr/share/doc/ns3/manual/html/_static ] ; then \
# 	  for where in manual models tutorial ; do \
# 	    for what in doctools.js language_data.js searchtools.js ; do \
# 	      rm debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
# 	      ln -s /usr/share/javascript/sphinxdoc/1.0/$${what} debian/ns3-doc/usr/share/doc/ns3/$${where}/html/_static/$${what}; \
# 	    done ; \
# 	  done ; \
# 	fi
# endif

override_dh_auto_clean:
	#-sh ./debian/clean-tree.sh
	rm -f src/core/model/version.cache
	dh_auto_clean

# ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# override_dh_compress:
# 	dh_compress -Xusr/share/doc/ns3/examples/  -Xusr/share/doc/ns3/manual/  -Xusr/share/doc/ns3/models/  -Xusr/share/doc/ns3/tutorial/
# endif

update-patches:
	cd debian/patches; \
	sed -i 's#ns-3[.][45][0-9]*#$(NS3_DIR)#g' *.diff *.patch
	@echo "Don't forget to update debian/control to rename the lib package,"
	@echo "and the SONAME in the debian/patches/library-soversion.diff patch."
	( grep -r 'ns-3[.][45][0-9]*' debian | grep -v $(NS3_DIR) ) || true
